'''
Created on 28 Mar 2022

@author: philren
'''

from pathlib import Path
import cffi
import shared_atomic.atomic_cffi_compile_steps as steps

ffi = cffi.FFI()
'''
    header = typedef long uchar;
                typedef long ushort;
                typedef LONG64 uint;
                typedef LONG64 ulong;
                typedef LONGLONG longlong;
                typedef long uwchar;
'''
hfilepath = Path.joinpath(Path(__file__).parent, 'atomic_csource_win10x64.h')
cfilepath = Path.joinpath(Path(__file__).parent, 'atomic_csource_win10x64.c')

with hfilepath.open() as hfile:
        header = ''.join(hfile.readlines())

ffi.cdef(header)
result_include = ["/std:c11", "-I\""+str(Path(__file__).parent.parent.absolute()) + "\""]
result_link = ["/LIBPATH:" + str(Path(__file__).parent.absolute())]
ffi.set_source('shared_atomic_win10_', """
        #include <windows.h>
        #include <BaseTsd.h>
        #include <stdbool.h>
        #include <stdio.h>
        #include <string.h>
        #include <stringapiset.h>
        #include <fileapi.h>
        #include <memoryapi.h>
        #include <handleapi.h>
        #include "shared_atomic\\atomic_decryption.h"
        """ + header,
                    sources=[str(cfilepath)],
                    extra_compile_args=result_include,
                    extra_link_args=result_link,
                    libraries=['libdecryption', 'libdecryption11'])


def generate_c():
    return steps.generate_c(ffi)

def compile():
    return steps.compile(ffi)

def main():

    #ffi.compile(verbose=True)

    ext_c_file = generate_c()
    outputfilename = compile()
    return outputfilename


if __name__ == "__main__":
    main()
